#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

class clovek
{
public:
	clovek(string jmeno, string prijmeni): m_jmeno(jmeno), m_prijmeni(prijmeni) {}
	virtual ~ clovek(void) = default;
	virtual void vypis(void) = 0;
protected:
	string m_jmeno;
	string m_prijmeni;
};

class student: public clovek
{
public:
	student(string jmeno, string prijmeni, string zeme): clovek(jmeno, prijmeni),
	m_zeme(zeme) {}
	virtual void vypis(void) {cout<<"student: "<<m_prijmeni<<", "<<m_zeme;}
protected:
	string m_zeme;
};

class ucitel: public clovek
{
public:
	ucitel(string jmeno, string prijmeni, string kabinet): clovek(jmeno, prijmeni),
	m_kabinet(kabinet) {}
	virtual void vypis(void) {cout<<"ucitel: "<<m_prijmeni<<", "<<m_kabinet;}
protected:
	string m_kabinet;
};


int main (void)
{
	vector<clovek *> lide_ve_skole;
	lide_ve_skole.push_back(new ucitel("Miroslav","Jilek","143"));
	lide_ve_skole.push_back(new ucitel("Ivan","Nekdo","150"));
	lide_ve_skole.push_back(new student("Julia","Dolgonogaja","Rusko"));
	lide_ve_skole.push_back(new student("Anton","Yuzhnyj","Ukrajina"));
	for(int i=0;i<4;i++)
	{
		lide_ve_skole[i]->vypis(); cout<<endl;
	}
	return 0;
}
